-- by RivalBomb
-- V1.0

steerable_update = Steerable.update;

ECC = {};
ECC.currentSpeedLevel = 6;
ECC.speedLevelActivated = false;
ECC.maxSpeedLevel = 6;
ECC.t = 0;

ECCFunction = function(self, dt)
	if self.motor ~= nil then
		if InputBinding.hasEvent(InputBinding.resetSpeed) then
			if ECC.speedLevelActivated then
				ECC.speedLevelActivated = false;
			end;
			local newSpeed = self.motor.maxForwardSpeed*3.6;
			self:setCruiseControlMaxSpeed(self.motor.maxForwardSpeed*3.6);
		end;
		if InputBinding.hasEvent(InputBinding.halfSpeed) then
			if ECC.speedLevelActivated then
				ECC.speedLevelActivated = false;
			end;
			local newSpeed = math.min(math.max(6, (self.motor.maxForwardSpeed*3.6)/3), 18);
			self:setCruiseControlMaxSpeed(newSpeed);
		end;
		if InputBinding.isPressed(InputBinding.increaseLevel) then
			ECC.t = ECC.t+dt
			if ECC.t >= 1100 then
				ECC.currentSpeedLevel = math.min(ECC.currentSpeedLevel+1, ECC.maxSpeedLevel);
				ECC.t = 0;
			end;
		end;
		if InputBinding.isPressed(InputBinding.decreaseLevel) then
			ECC.t = ECC.t+dt
			if ECC.t >= 1100 then
				ECC.currentSpeedLevel = math.max(ECC.currentSpeedLevel-1, 1);
				ECC.t = 0;
			end;
		end;
		if not InputBinding.isPressed(InputBinding.increaseLevel) and not InputBinding.isPressed(InputBinding.decreaseLevel) then
			ECC.t = 1100;
		end;
		if InputBinding.hasEvent(InputBinding.activateSpeedLevel) then
			ECC.speedLevelActivated = not ECC.speedLevelActivated;
		end;
		if ECC.speedLevelActivated then
			local newSpeed = ((self.motor.maxForwardSpeed*3.6)/ECC.maxSpeedLevel)*ECC.currentSpeedLevel;
			self:setCruiseControlMaxSpeed(newSpeed);
			
			if self.isEntered then
				if g_currentMission.showVehicleInfo and g_currentMission.showHudEnv and g_currentMission.renderTime then
					setTextAlignment(RenderText.ALIGN_RIGHT);
					setTextColor(0.9, 0.9, 0.9, 0.9);
					renderText(1, 0, 0.015, "Fahrstufe: " .. ECC.currentSpeedLevel);
				end;
			end;
		end;
	end;
end;

Steerable.update = function(self, dt)
	steerable_update(self, dt);
	ECCFunction(self, dt);
end;